#!/usr/bin/perl
#
# dclinks98admin.cgi
# Geschrieben von David S. Choi, dc@sitedeveloper.com
# 5 Feb 1998
#
# Ins Deutsche bersetzt von Dan Sepeur
# Mail: dan@tentacle.de
# URL: http://www.tentacle.de/tag4tag
#
##########  YOU MUST KEEP THIS COPYRIGHTS NOTICE INTACT ###############
# Copyright  1997 DCScripts All Rights Reserved
# Als einen Teil des Installationsvorganges werden Sie nach der
# Ihrer Zustimmung zu den Linzensbedingungen gebeten.
# Diese Zustimmung ist ein legaler Kontrakt, welcher die Lizensbedingungen
# zwischen Ihnen, DCScripts und DCLinks97 spezifiziert.
# Bitte stellen Sie sicher, da Sie die nachfolgende Information auf-
# merksam lesen bevor Sie die Software installieren und benutzen.
# Esseidenn, Sie haben eine andere, von dieser hier abweichende
# Lizensbestimmung von DCScripts.
# Wenn Sie den Lizensbedingungen nicht zustimmen, stellen Sie sicher
# da Sie alle Kopien und Programmteile dieser Software von Ihrem
# Computer lschen.
#
# Versionen dieser Software 
# Sie knnen so viele Versionen von DCLinks97 installieren, wie Sie
# mchten.
# 
# Vereinbarung zum Weiterverkauf
# Die Distribution dieser Software und/oder der Dokumentation mit
# anderen Produkten (kommerziell oder andersartig) oder durch andere
# elektronische Vertreitungsmittel ohne die ausdrckliche schriftliche
# Genehmigung von DCSripts nicht erlaubt.
# Alle Rechte an DCLinks97 und den Dokumentationen garantieren nicht
# den einwandfreien Betrieb von DCLinks97, stehen aber unter den
# Lizensvereinbarungen von DCScripts.
#
# 
# Garantiebestimmungen
# DIESE SOFTWARE UND DIE MITGELIEFERTE DOKUMENTATION WIRD SO VERTRIEBEN
# WIE SIE ERSTELLT WURDE. UND DAS OHNE DEN ANSPRUCH AUF VOLLSTNDIGKEIT
# UND OHNE DIE GARANTIE AUF GESCHWINDIGKEIT UND LAUFFHIGKEIT IN JEDEM
# FALL, DA JEDER RECHNER SICH VON DEM ANDEREN UNTERSCHEIDET UND SOMIT
# IMMER ANDERS KONFIGURIERT IST. DER USER MUSS DIESEN VEREINBARUNGEN
# ZUSTIMMEN UND GIBT AN DIE SOFTWARE AUF SEIN EIGENES RISIKO ZU NUTZEN.
# HKDESIGN BERNIMMT KEINERLEI HAFTUNG FR FEHLERHAFTE BEDIENUNG UND
# DARAUS RESULTIERENDEN FEHLERN AN HARD- ODER SOFTWARE.
#
#
# CREDITS = Dieses Script benutzt Matt Wrights cookie.lib Library
# Sie knnen Ihre freie Kopie von www.worldwidemart/scripts downloaden.
#
###########################################################################

# Geben Sie hier bitte den Pfad zu diesem Script festlegen
# Wenn das Script so arbeitet, lassen Sie es so

$path = ".";

# Librarys einbinden...

require "$path/dclinks98.setup";
require "$path/dclinks98admin.setup";

# $cgidir ist schon in der Datei dclinks98.setup definiert

require "$cgidir/cgi-lib.pl";
require "$cgidir/cookie.lib";

# ----------------- Diese Zeilen brauchen Sie nicht zu ndern --------------#

# Einlesen der Formulardaten

&ReadParse;

# Wenn die Passwortdatei nicht existiert, erstellen Sie eine
# solche mit dem Usernamen dscripts und dem Passwort descripts

&check_password_file;

print "Content-type: text/html\n";

if ($ENV{'QUERY_STRING'} eq "LOGON") {
	&logon;
}

if ($in{'change_password'}) {
	print "\n";
	&change_password_form;
	&display_output;
	exit(0);
}

$action = $in{"action"};

if ($action eq "change_password") {

   &change_password;

	print "\n";

   $header = $display_change_header;
   $header = $display_change_sub_header;
   &logon;

}	

&check_password;

if ($action eq "list") {

	print "\n";
   &display_links;

} elsif ($action eq "remove") {

	print "\n";
	$header = $display_removedone_header;
	$sub_header = $display_removedone_sub_header;
    &remove_links;

} elsif ($action eq "add_links") {

	print "\n";
	$header = $display_edone_header;
	$sub_header = $display_edone_sub_header;
    &add_links;

} elsif ($action eq "edit_form") {

	print "\n";
	$header = $display_eform_header;
	$sub_header = $display_eform_sub_header;
    &display_form;   
   
} else {

	print "\n";
	$header = $display_main_header;
	$sub_header = $display_main_sub_header;
	&display_main;

}

&display_output;

exit(0);

sub display_main {

	$html_output .= qq~
	
	<blockquote>
	<br><a href="$adminurl?action=list"><b>Links lschen</b></a>
	Whlen Sie diese Option, um Links aus der Datenbank zu entfernen
	<br><a href="$adminurl?action=list&type=edit">Editieren von Links</a>
	Whlen Sie diese Option um Linkoptionen zu ndern
	</blockquote>

~;
}

sub remove_links {

	@records = split(/\0/,$in{'records'});

	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	$new_links = "";
	
	foreach $line (@linksdata) {

		chop($line) if ($line =~ /\n$/);
		@row = split(/\|/,$line);			
		$hit = "no";

		foreach ($j = 0;$j <= @row-1;$j++) {
			$rowdata{$link_fields[$j]} = $row[$j];
		}

		foreach $record (@records) {
			if ($line =~ /$record\|/) {
				$hit="yes";
				$html_output .= qq~
				<li>
				<input type="$type" name="records" value="$rowdata{'ID'}">
				<a href="$rowdata{"Homepage"}">$rowdata{"Name"}</a>
				$rowdata{"Beschreibung"}
				</li>
				~;
				$last;
			}
		}
		
		unless ($hit eq "yes") { $new_links .= "$line\n"; }
	}

	open(LINKSDATA,">$datafile") || die $!;
	flock(LINKSDATA,2);
		print LINKSDATA $new_links;
	flock(LINKSDATA,8);
	close(LINKSDATA);

}


sub display_links {

	if ($in{'type'}) {
		$type = "radio";
		$todo = "edit_form";
		$submit_value = "Editieren des selektierten Links";
		$header = $display_edit_header;
		$sub_header = $display_edit_sub_header;
	} else {
		$type = "checkbox";
		$todo = "remove";
		$submit_value = "Link lschen";
		$header = $display_remove_header;
		$sub_header = $display_remove_sub_header;
	}
	
	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	$html_output .= qq~
	<form action="$adminurl" method="post">
	<input type="hidden" name="action" value="$todo">
	~;
	
	foreach $category (@Kategorie_list) {

		$html_output .= qq~
		<P align="center">
		<B>Gesichtete Links in $category</b>
		<P align="center">
		~;
		
		foreach $line (@linksdata) {
			@row = split(/\|/,$line);
	
			foreach ($j = 0;$j <= @row-1;$j++) {
				$rowdata{$link_fields[$j]} = $row[$j];
			}
			
			if ($rowdata{$link_fields[$cat_id]} =~ /$category/) {
				$html_output .= qq~
				<li>~;
				$html_output .= &list_record($type,@rowdata);
				$html_output .= qq~
				</li>
				~;			
			}	
		}
	}

	$html_output .= qq~
	<p align="center">
	<input type="submit" value="$submit_value">
	<input type="reset" value="Reset">	
	</p>
	</form>
	~;
}

sub change_password_form {

	$header = "Change Password and Username";
	$sub_header = "Komplettieren Sie das nachfolgende Formular um Ihre Admin-Informationen zu ndern";
	
	$html_output .= qq~
	
	<form action="$adminurl" method="post">
	<input type="hidden" name="action" value="change_password">
	Alter Username: <input type="text" name="username" width="40"><br>
	Neuer Username: <input type="text" name="new_username" width="40"><br>
	Altes Passwort: <input type="password" name="password" width="40"><br>
	Neues Passwort: <input type="password" name="new_password1" width="40"><br>
	Neues Passwort: <input type="password" name="new_password2" width="40"><br>
	<input type="submit" value="Jetzt ndern">
	<input type="reset" value="Reset">
	</form>
~;
}


sub display_logon {

	$html_output .= qq~
	
	<form action="$adminurl" method="post">
	<input type="hidden" name="action" value="logon">
	Username: <input type="text" name="username" value="guest" width="40"><br>
	Passwort: <input type="password" name="password" value="guest" width="40"><br>
	<input type="submit" value="Einloggen">
	<input type="submit" name="change_password" value="Passwort ndern">
	</form>
~;
}


sub display_output {

	open(TEMPLATE,"$booktemplate") || die $!;
		while (<TEMPLATE>)
		{
			$template .= $_;
		}
	close(TEMPLATE);
	$template =~ s/\$HTML_OUTPUT/$html_output/g;
	$template =~ s/\$HEADER/$header/g;
	$template =~ s/\$SUB_HEADER/$sub_header/g;
	print $template;

}

sub change_password {

	if (!$in{'username'}) {

       &error(no_username);

	} elsif (!$in{'password'}) {

       &error(no_password);

	}

	$username = $in{'username'};
	$new_username = $in{'new_username'};
	$password = $in{'password'};
	$new_password1 = $in{'new_password1'};
	$new_password2 = $in{'new_password2'};

	open(PASSWORD,"$password_file") || &error(password_file);
		$username_password = <PASSWORD>;
		chop($username_password) if ($username_password =~ /\n$/);
	close(PASSWORD);

   ($orig_username,$orig_password) = split(/:/,$username_password);
   
   $test = crypt($password, substr($password, 0, 2));

	if (!($test eq $orig_password && $orig_username eq $username)) {

      	&error(bad_combo);

	} elsif ($new_password1 ne $new_password2) {

		&error('not_same');

	} else {

		$new_password = crypt($new_password1, substr($new_password1, 0, 2));
		$username_password = join(":",$new_username,$new_password);
		
		open(PASSWORD,">$password_file") || &error(password_file);
			print PASSWORD "$username_password\n";
   		close(PASSWORD);

		&SetCookies('username',$new_username,'password',$new_password);

	}

   print "\n";
	
}


###
###
### subroutine check_password
###
###

sub check_password {

	open(PASSWORD,"$password_file") || &error(password_file);
		$username_password = <PASSWORD>;
      	chop($username_password) if $username_password =~ /\n$/;
   	close(PASSWORD);

	($orig_username,$orig_password) = split(/:/,$username_password);

	if (&GetCookies('username','password')) {

		$username = $Cookies{'username'};
		$password = $Cookies{'password'};

		if (!($password eq $orig_password && $username eq $orig_username)) {
	      &error(bad_combo);
		}

	} else {

		if ($in{'action'} eq "logon") {

			if (!$in{'username'}) {
				&error(no_username);
			}
			elsif (!$in{'password'}) {
		       &error(no_password);
			}
			
			$test = crypt($in{'password'}, substr($in{'password'}, 0, 2));
	
			if (!($test eq $orig_password && $in{'username'} eq $orig_username)) {
		      &error(bad_combo);
			}
			
			&SetCookies('username',$in{'username'},'password',$test);
			
		} else {
		
			&logon;
		}		
	}
	
}

sub logon {
	print "\n";
	$header = $display_logon_header;
	$sub_header = $display_logon_sub_header;
	&display_logon;
	&display_output;
	exit(0);
}


sub error {

   $error = $_[0];

	print "\n";

    if ($error eq 'bad_combo') {
      $header = "Falsche Username + Passwort Kombination";
      $sub_header = "Sie haben eine falsche Username-Passwort Kombination eingegeben.<br>  Gehen Sie zurck und versuchen Sie es erneut.";
    }
   elsif ($error eq 'password_file') {
      $header = "Kann Passwortdatei nicht einlesen";
      $sub_header = "Kann Passwortdatei zum Einlesen nicht ffnen!<br> Prfen Sie die Rechte und versuchen Sie es erneut.";
   }
   elsif ($error eq 'no_username') {
      $header = "Kein Username angegeben";
      $sub_header = "Sie haben vergessen, den Usernamen angegeben.  Prfen Sie die Rechte und versuchen Sie es erneut.";
   }
   elsif ($error eq 'no_password') {
      $header = "Kein Passwort eingegeben";
      $sub_header = "Sie haben kein Passwort eingegeben.  Prfen Sie die Rechte und versuchen Sie es erneut.";
    }
   elsif ($error eq 'not_same') {
      $header = "Falsches Passwort angegeben";
      $sub_header = "Das Passwort, welches Sie angegeben haben ist nicht korrekt.";
      $sub_header .= "<br>Wenn Sie denken, Sie haben sich vertippt, so versuchen Sie es erneut.\n";
   }
   elsif ($error eq 'no_change') {
      $header = "Kann Passwortdatei zum beschreiben nicht ffnen.";
      $sub_header = "Kann Passwortdatei zum beschreiben nicht ffnen!  Passwort wurde nicht gendert!";
   }

   &display_output;
   exit(0);
}

sub check_password_file {

	if (!(-e "$password_file")) {
	   	$username = "dcscripts";
   		$password = crypt("dcscripts", substr("dcscripts", 0, 2));
   		$username_password = join(":",$username,$password);
		open(PASSWORD,">$password_file") || &error(password_file);
			print PASSWORD "$username_password\n";
		close(PASSWORD);
	}
}


sub list_record {

	local($type,@rowdata) = @_;
	local($output);
	
	$output .= qq~
	<input type="$type" name="records" value="$rowdata{'ID'}">
	<a href="$rowdata{"Homepage"}">$rowdata{"Name"}</a>
	$rowdata{"Beschreibung"}
	~;
	
	$output;
}

sub add_links {

	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	$id = $in{'records'};
	($date,$localtime) = &get_date();
	$date = $localtime." ".$date;

	$in{'ID'} = $id;
	$in{'Date'} = $date;

	foreach $field (@link_fields)
	{
		$in{$field} =~ s/\|/\s/g;
		$update .= $in{$field}."|";
	}
	
	chop($update);
	$update .= "\n";

	foreach $link (@linksdata) {
		if ($link =~ /$id\|/) {
			$newline .= $update;
			@row = split(/\|/,$link);
			foreach ($j = 0;$j <= @row-1;$j++) {
				$rowdata{$link_fields[$j]} = $row[$j];
			}

		} else {
			$newline .= $link;
		}
	}

	open(LINKSDATA,">$datafile") || die $!;
	flock(LINKSDATA,2);
		print LINKSDATA $newline;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	$html_output .= qq~
	<a href="$rowdata{"Homepage"}">$rowdata{"Name"}</a>
	$rowdata{"Beschreibung"}
	~;
		
}

sub display_form {


	$id = "$in{'records'}";

	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);
	
	foreach $line (@linksdata) {
		chop($line) if ($line =~ /\n$/);
		if ($line =~ /$id\|/) {
			@row = split(/\|/,$line);
			last;
		}
	}
	
	foreach ($j = 0;$j <= @row-1;$j++) {
		$record{$link_fields[$j]} = $row[$j];
	}
		
	$html_output .= qq~
	<center>
	<table border="0">

	<form action="$adminurl" method="post">
	<input type="hidden" name="action" value="add_links">
	<input type="hidden" name="records" value="$id">~;
	
	foreach $link_field (@link_fields)
	{
		$html_output .= &table_row($link_field,$field_input_type{$link_field},$record{$link_field});
	}
	
	$html_output .= qq~
	<tr>
	<td colspan="2" align="center">
	<input type="submit" value="Link updaten!">
	<input type="reset">
	</form>
	</table>
	</center>~;
}

sub table_row {

	local($field,$type);
	($field,$type,$value) = @_;
	local($table_row);
	
	if ($type eq "text") {
		$table_row .= qq~
		<tr>
		<td valign="top">
		$field
		</td>
		<td>
		<input type="$type" name="$field" value="$value" size="40">
		</td>
		</tr>
		~;
	} elsif ($type eq "textarea") {
		$table_row .= qq~
		<tr>
		<td valign="top">
		$field
		</td>
		<td>
		<textarea name="$field" rows="6" cols="40" wrap="physical">$value</textarea>
		</td>
		</tr>
		~;
		
	} elsif ($type eq "select") {
		@option_list = eval("@".$field."_list");
		$table_row .= qq~
		<tr>
		<td valign="top">
		$field
		</td>
		<td>
		<select name="$field">~;
		foreach $option (@option_list)
		{
			if ($option eq $value) {
				$table_row .= "<option selected value=\"$option\">$option\n";
			} else {
				$table_row .= "<option value=\"$option\">$option\n";
			}
		}
		
		$table_row .= qq~
		</select>
		</td>
		</tr>
		~;

	}

	
	$table_row;
}


sub get_date {

   local($date,$localtime);
   
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("Januar","Februar","Maerz","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");

   $localtime = "$hour\:$min\:$sec";
   $date = "$mday/$month/$year";
   chop($date) if ($date =~ /\n$/);
   chop($local) if ($local =~ /\n$/);

   ($date,$localtime);
   
}
